SystemOrganization addCategory: #'Magritte-RDB-MySQL'!
SystemOrganization addCategory: #'Magritte-RDB-MySQL-Tests'!
SystemOrganization addCategory: #'Magritte-RDB-Descriptions'!
SystemOrganization addCategory: #'Magritte-RDB'!

!String methodsFor: '*magritte-rdb' stamp: 'kph 11/17/2007 02:02'!
asColumns

	^ self findTokens: (Character value: 138) asString  escapedBy: nil.
	
	! !

TestResource subclass: #MAMysqlTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MAMysqlTestResource methodsFor: 'as yet unclassified' stamp: 'kph 7/1/2008 19:20'!
databaseInterface

^ MYSQLTester new! !

!MAMysqlTestResource methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:12'!
setUp

	self databaseInterface execute: 'DROP TABLE IF EXISTS TESTING'.
	self databaseInterface execute: 'CREATE TABLE `testing` (
	  `id` int(11) NOT NULL auto_increment,
	  `bool` char(5) default NULL,
	  `shortbool` char(1) default NULL,
	  `password` char(41) default NULL,
	  `tokens` varchar(255) default NULL,
	  `price` char(10) default NULL,
	  `priceUsd` char(10) default NULL,
	  `string` char(20) default NULL,
	  `extFile` char(20) default NULL,
	  `extFiles` char(20) default NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1'  ! !

MAVisitor subclass: #MACoercingVisitor
	instanceVariableNames: 'input output stringWriter stringReader client convert'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MACoercingVisitor commentStamp: 'kph 10/14/2007 14:35' prior: 0!
Coercing visitors are expected to be instanciated once for a particular db, or db access, rather than for every individual value read/write. For this reason we cache a stringWriter and a stringReader for general use.

convert is a flag which signals whether or not the database driver is to apply its default type conversions on reading/writing the db.!

!MACoercingVisitor class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 19:38'!
client: aDb

	^ self basicNew client: aDb; initialize; yourself! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 9/20/2007 19:38'!
client: anObject
	"Set the value of client"

	client := anObject! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 11/18/2007 05:00'!
coerce: anObject description: aDescription 
	convert := false.
	output := nil.
	self input: (self read: anObject description: aDescription)
		during: [ self visit: aDescription ].
	 
	^  output! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 11/18/2007 20:47'!
coercedDefaultForDescription: aDescription  
 
	| aStream |
	
	convert := false.
	output := nil.
	self input: (aDescription default)
		during: [ self visit: aDescription ].
	 
	aStream := String new writeStream.

	convert 
		ifTrue: [ client writeConverting: output on:aStream]
		ifFalse: [ aStream nextPutAll: output ].
	
	^ aStream contents! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 9/20/2007 23:51'!
input: anObject during: aBlock
	| previous |
	previous :=  input.  input := anObject.
	aBlock ensure: [ input := previous ]! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 9/20/2007 23:54'!
read: anObject description: aDesc

	^ anObject! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 9/20/2007 19:17'!
stringReader

	^ stringReader ifNil:[ stringReader := MAStringReader ]

	! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 9/20/2007 19:16'!
stringWriter

	^ stringWriter ifNil:[ stringWriter := MAStringWriter ]

	! !

!MACoercingVisitor methodsFor: 'accessing' stamp: 'kph 1/14/2008 02:40'!
visitOptionDescription: aDescription
	self visit: aDescription reference
	! !

MACoercingVisitor subclass: #MAFromRDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 00:48'!
coerce: anObject description: aDescription to: model

	self coerce: anObject description: aDescription.

	aDescription accessor write: output to: model.
	! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 21:58'!
inputFromString: aDesc

	^ self stringReader read: input readStream description: aDesc! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:02'!
visitBooleanDescription: aDesc
	
	 input ifNotNil: [ input := input asLowercase ].
	
 	 super visitBooleanDescription: aDesc! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:02'!
visitClassDescription: aDesc

 	output := input ifNil:[ aDesc default yourself ] ifNotNil: [ Smalltalk at: input asSymbol ] 
 
	 ! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:01'!
visitDescription: aDesc

 	output := input ifNil:[ aDesc default yourself ] ifNotNil: [ self inputFromString: aDesc ] ! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:11'!
visitFileDescription: anObject
 
	output := anObject kind 
		fromDBString: ((input ifNil: [ anObject default yourself ]) ifNil: [ ^ nil ]).
! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:02'!
visitMagnitudeDescription: aDesc
	
	output := input! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 04:25'!
visitMultipleOptionDescription: aDesc
	
	| default |
	default := aDesc propertyAt: #default ifAbsent: [ #() ].
	input ifNil: [ output := default. ^ self ].
	
	input := input asColumns collect: [ :each | self coerce: each description: aDesc reference ].
	
	output := default class withAll: input.
	! !

!MAFromRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:03'!
visitPriceDescription: aDesc
	  input ifNotNil: [ input := input asFixedDecimal: 2].
	 super visitPriceDescription: aDesc! !

MAFromRDB subclass: #MAMySqlFromDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 01:51'!
coerce: resultSet using: descriptions to: model

	resultSet currentRowAsValuesWithIndexDo: [ :val :i | self coerce: val description: (descriptions at: i) to: model ].

	^ model! !

!MAMySqlFromDB methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 16:28'!
inputFromString: aDesc

	(input size > 0 and: [ input last isSeparator ]) ifTrue: [ input := input withoutTrailingBlanks ].

	^ super inputFromString: aDesc
! !

MACoercingVisitor subclass: #MAToRDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

MAToRDB subclass: #MAMySqlToDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MAMySqlToDB commentStamp: 'kph 9/20/2007 19:10' prior: 0!
In writing to the DB we preserve nil.!

!MAMySqlToDB methodsFor: 'as yet unclassified' stamp: 'kph 3/29/2009 22:19'!
visitPasswordDescription: aDesc 
 
	output := input 
				ifNotNil: 
					[(input size = 41 and: [input beginsWith: '*']) 
						ifTrue: [ convert := true. input ]
						ifFalse: 
							[ convert := false.
							'PASSWORD("' , input asString , '")'. 
							]].
 ! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 23:37'!
coerce: anObject description: aDescription on: aStream
 
	self coerce: anObject description: aDescription.

	convert 
		ifTrue: [ client writeConverting: output on:aStream ]
		ifFalse: [ aStream nextPutAll: output ]
	! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 23:46'!
read: anObject description: aDesc

	^ (aDesc accessor read: anObject) ifNil: [ aDesc default yourself ]! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:00'!
readInput: aDesc

	^ (aDesc accessor read: input) ifNil: [ aDesc default yourself ]! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 3/23/2009 02:03'!
visitBooleanDescription: aDesc
	"We write true/false, the db session should have its own convention for storing booleans"
	
	"ask the database session handle the coercion"
	convert := true.

	output := input.
	! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 10/14/2007 14:39'!
visitClassDescription: aDesc
 	
	output := input name asString.
 	convert := true.! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 23:49'!
visitDescription: aDesc

	convert := true.

	aDesc isWithId ifTrue: [ ^ input key ].

	output := self stringWriter write: (input ifNil: [ ^ output := nil ]) description: aDesc.
	
 ! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:07'!
visitFileDescription: aDesc
 	
	output := input ifNotNil: [ input asDBString ].
 	convert := true.! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 23:49'!
visitMagnitudeDescription: aDesc

	convert := true.
	output := input
 ! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 03:54'!
visitMultipleOptionDescription: anObject
	
	
	| results | 
	"not working"
	convert := true.
	input ifNil: [ ^ output := nil ].
	
	results := input collect: [:each | 
		output := nil.
		(self input: each during: [ self visitOptionDescription: anObject ]).
		output.
		].
 
	output := results joinUsing: (Character value: 138)
  ! !

!MAToRDB methodsFor: 'as yet unclassified' stamp: 'kph 2/2/2008 00:33'!
visitPriceDescription: aDesc
	super visitPriceDescription: aDesc.
 	output := output ifNotNilDo: [ :v | (v asFixedDecimal:2) asString ]! !

MAVisitor subclass: #MAQueryModel
	instanceVariableNames: 'selectDescriptions selectFields joins results tables parent from where selectAccessors accessorStack modelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MAQueryModel class methodsFor: 'as yet unclassified' stamp: 'kph 8/13/2007 03:35'!
modelClass: desc 
	^ (self basicNew)
		setModelClass: desc;
		initialize;
		yourself! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/21/2007 17:31'!
accessorFor: aDesc

	^ selectDescriptions detect: [ :d | d = aDesc ] ifNone: [ nil ]! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/22/2008 02:24'!
initialize
	tables := OrderedCollection new.
	selectDescriptions := OrderedCollection new.
	selectFields := OrderedCollection new.
	 
	accessorStack := nil.
	results := OrderedCollection new.
	joins := OrderedCollection new.
 
	! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/13/2007 16:27'!
joins
	^ joins! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 10/18/2007 03:02'!
modelClass
	^ modelClass! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/13/2007 16:00'!
parent: newParent during: aBlock

	| prev |
	
	prev := parent.
	parent := newParent.
	aBlock ensure: [ parent := prev ].! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 9/4/2008 02:00'!
performQuery
 	
 ! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 10/18/2007 02:57'!
performVisit

	self visit: self modelClass description  ! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/14/2007 01:17'!
pushAccessor: newAccessor during: aBlock 
	accessorStack := accessorStack ifNil: [newAccessor]
				ifNotNilDo: [:parentAccessor | parentAccessor chainTo: newAccessor].
	aBlock ensure: 
			[accessorStack := accessorStack chainUnlinkLast ]! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 2/10/2009 14:29'!
selectDescriptions
	selectDescriptions ifEmpty: [ self performVisit. ].

	^ selectDescriptions! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/22/2008 02:57'!
selectFields

	selectFields ifEmpty: [ self performVisit. ].
	
	^ selectFields! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 3/17/2009 23:56'!
setModelClass: aClass
	modelClass  := aClass.
! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/13/2007 15:00'!
tables

	^ tables! !

!MAQueryModel methodsFor: 'visiting' stamp: 'kph 8/14/2007 00:03'!
visitContainer: aDescription

	  self visitAll: aDescription children  ! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 8/20/2007 14:09'!
visitElementDescription: aDescription 
	|  accessor |
 
	accessor := accessorStack ifNil: [aDescription accessor]
				ifNotNilDo: [:acc | acc copy chainTo: aDescription accessor].
 
	selectDescriptions add: (aDescription copy accessor: accessor)..
! !

!MAQueryModel methodsFor: 'accessing' stamp: 'kph 10/18/2007 03:13'!
visitRelationDescription: aDesc
 	
	| joinTo |
	
	aDesc joinField ifNil: [ ^ self ].
	
	joinTo:= aDesc reference. 
	
	self joins add: (aDesc -> joinTo).
	 
	self pushAccessor: aDesc accessor during: [ self visit: joinTo ]! !

MAQueryModel subclass: #MAQuerySql
	instanceVariableNames: 'sql sqlWhere sqlOrderBy table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:01'!
andWhere: desc is: aValue
	
	sqlWhere := sqlWhere , ' AND ', desc fieldRef, ' = ' ,  (self valueToMysql: aValue).
		
	 ! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:11'!
getSqlOrderBy

	sqlOrderBy isEmptyOrNil ifFalse: [ sql << ' ORDER BY ' << sqlOrderBy ]! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:11'!
getSqlWhere

	sqlWhere isEmptyOrNil ifFalse: [ sql << ' WHERE ' << sqlWhere ]! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 9/4/2007 14:24'!
getUnique

	^ self performQuery at: 1 ifAbsent: [ nil ]! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:01'!
orWhere: desc is: aValue
	
	sqlWhere := sqlWhere , ' OR ', desc fieldRef, ' = ' ,  (self valueToMysql: aValue).
		
	 ! !

!MAQuerySql methodsFor: 'Magritte-RDB' stamp: 'kph 9/15/2008 21:52'!
performQuery
 	
	results := OrderedCollection new.
		
	self performQueryDo: [ :ea | results add: ea ].

	results do: [ :ea | ea postRealize; postRealizeStoreIfNeeded ].

	^  results! !

!MAQuerySql methodsFor: 'Magritte-RDB' stamp: 'kph 3/23/2009 02:42'!
performQueryDo: doBlock

	super performQuery.
			
	self modelClass databaseInterface
		execute: self theQuery 
		readUsing: selectDescriptions 
		to: self modelClass newToReadInto		  
		do: doBlock
		
		 ! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 10/18/2007 02:58'!
performVisit

	self visit: (self modelClass description select: [ :d | d isPersisted | d joinField notNil ]).
! !

!MAQuerySql methodsFor: 'accessing' stamp: 'kph 3/17/2009 23:42'!
setSqlTableName: aSqlTableName

	table := aSqlTableName! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:06'!
sqlFrom

	 sql << ' FROM ' << table! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:09'!
sqlJoins

	| actualJoins |
	
	actualJoins := self joins reject: [ :join | join value pointTo = table ].
	
	actualJoins 
		do: [ :join | sql << ' LEFT JOIN ' << join value pointTo << ' ON ' << join key joinRef << ' = ' << join value pointTo << '.' << join key joinToField ] 
		separatedBy: [ sql << ' ' ].
	
	! !

!MAQuerySql methodsFor: 'accessing' stamp: 'kph 1/25/2008 14:00'!
sqlOrderBy
	^ sqlOrderBy! !

!MAQuerySql methodsFor: 'accessing' stamp: 'kph 1/25/2008 14:00'!
sqlOrderBy: anObject 
	sqlOrderBy := anObject! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 9/4/2008 02:05'!
sqlSelect

	sql << 'SELECT '.
	
	self selectFields do: [ :ea | sql << ea ] separatedBy: [ sql << ', ' ].
	
	sql << ' '.! !

!MAQuerySql methodsFor: 'Magritte-RDB' stamp: 'kph 8/22/2008 03:22'!
sqlUpdateFrom: model

	sql << 'UPDATE ' << table.
	
	self selectFields do: [ :ea | sql << ea << '=' << ''] separatedBy: [ sql << ', ' ].
 
	sql << ') '. ! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:10'!
sqlWhere

	 ^ sqlWhere! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:00'!
sqlWhere: w

	  sqlWhere := w! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:04'!
theQuery

	sql := String new writeStream.
	
	self sqlSelect;
		sqlFrom;
		sqlJoins;
		getSqlWhere;
		getSqlOrderBy;
		yourself.
		
	^ sql contents
	
	! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 03:12'!
theUpdateFrom: model

	sql := String new writeStream.
	
	self sqlUpdateFrom: model;
		getSqlWhere;
		yourself.
		
	^ sql contents
	
	! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:03'!
valueToMysql: value

	^ JdmFactory41 instance fieldConverter convertToMysql: value! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 8/20/2007 14:05'!
visitElementDescription: aDescription 
	|  table |


	aDescription isPersisted ifFalse: [ ^ self ].
	
	table := aDescription pointTo.
	(self tables includes: table) ifFalse: [self tables add: table].
	
	selectFields add: aDescription fieldRef.

	super visitElementDescription: aDescription.! !

!MAQuerySql methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:02'!
where: desc is: aValue
	
	sqlWhere :=  desc fieldRef, ' = ' , (self valueToMysql: aValue).
		
	 ! !

MAQuerySql subclass: #MASqlCreateTableVisitor
	instanceVariableNames: 'columnDefinitions fieldName isRequired default type dbSession engine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/18/2009 02:05'!
coercedDefaultForDescription: aDesc

	^ (MAMySqlToDB client: dbSession) coercedDefaultForDescription: aDesc! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 20:54'!
defaultFrom: aDesc

	| |
	
 
	isRequired not ifTrue: [  ^ ' DEFAULT ', default   ].

	(isRequired and: [ default ~= 'NULL' ]) ifTrue: [  ^ ' NOT NULL DEFAULT ', default  ].

	isRequired ifTrue: [  ^ ' NOT NULL ' ].! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 12:07'!
initialize! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/18/2009 02:04'!
setDbSession: s

	dbSession := s! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/18/2009 02:32'!
setEngine: e

	engine := e! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 12:11'!
sqlColumnDefinitions

	columnDefinitions := OrderedCollection new.
	
	(self modelClass description select: [ :d | d isPersisted | d joinField notNil ]) children collect: [ :desc | self visit: desc ].
	
	columnDefinitions addAll:  modelClass sqlIndexDefinitions.
	
	^ columnDefinitions! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 3/18/2009 02:35'!
sqlCreateTable

^ 'CREATE TABLE ' , table , ' ( ', ( self sqlColumnDefinitions joinUsing: ', ' ) , ' ) ENGINE=' , engine! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 21:54'!
visit: aDesc

	fieldName := aDesc getFieldName.  
	isRequired := aDesc isRequired.
	type := aDesc fieldSize.
	
	default :=  self coercedDefaultForDescription: aDesc.
	
	super visit: aDesc! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 13:10'!
visitBooleanDescription: aDesc

	| size |

	size := aDesc trueString size max: aDesc falseString size.

	columnDefinitions add: '`', fieldName , '` char(' , size asString , ')' ,  (self defaultFrom: aDesc)  
	! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 20:09'!
visitClassDescription: aDesc

 
	columnDefinitions add: '`', fieldName , '` varchar(50)' ,  (self defaultFrom: aDesc)  
	
 ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 20:21'!
visitDateDescription: aDesc

 
	columnDefinitions add: '`', fieldName , '` date ' ,  (self defaultFrom: aDesc)  
	
 ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:20'!
visitElementDescription: anObject
	self visitDescription: anObject! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 22:20'!
visitMemoDescription: aDesc

  
	type := type ifNil: [ 'smalltext' ].

	(type isInteger and: [ type > 65536 ]) ifTrue: [ type := 'mediumtext' ]. 
 	(type isInteger and: [ type > 255 ]) ifTrue: [ type := 'smalltext' ]. 
 	
	type isInteger  ifTrue: [ type := 'varchar(', type asString , ')' ]. 
 
	columnDefinitions add: '`', fieldName , '` ', type ,' ' , (self defaultFrom: aDesc)  
	! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 13:10'!
visitNumberDescription: aDesc
 
	columnDefinitions add: '`', fieldName , '` int(11)' , ((aDesc propertyAt: #autoIncrement ifAbsent:[ false ]) ifTrue: [' AUTO_INCREMENT'] ifFalse: [self defaultFrom: aDesc]).
	! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 13:11'!
visitReferenceDescription: aDesc
	 
	super visit: aDesc reference.
	

 ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 11:21'!
visitRelationDescription: anObject
	self visitReferenceDescription: anObject! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 22:17'!
visitStringDescription: aDesc

	type := type ifNil: [ 'varchar(100)' ].

	(type isInteger and: [ type > 30 ]) ifTrue: [ type := 'varchar(', type, ')' ].
	
	type isInteger ifTrue: [ type := 'char(', type asString, ')' ].
	
	columnDefinitions add: '`', fieldName , '` ', type  ,  (self defaultFrom: aDesc)  ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 21:02'!
visitTimeDescription: aDesc

 
	columnDefinitions add: '`', fieldName , '` time ' ,  (self defaultFrom: aDesc)  
	
 ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 21:04'!
visitTimeStampDescription: aDesc

 
	columnDefinitions add: '`', fieldName , '` datetime ' ,  (self defaultFrom: aDesc)  
	
 ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 20:05'!
visitToManyRelationDescription: anObject
	 ! !

!MASqlCreateTableVisitor methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 22:21'!
visitToOneRelationDescription: anObject
	 ! !

!MAVisitor methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 2/3/2008 22:19'!
visitButtonDescription: anObject
	self visitNonAccessingDescription: anObject! !

!MAVisitor methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 8/19/2007 04:47'!
visitDescriptionDescription: anObject
	self visitElementDescription: anObject! !

!MAVisitor methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 3/19/2009 23:42'!
visitDividerDescription: anObject
	self visitElementDescription: anObject! !

!MAVisitor methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 2/3/2008 22:20'!
visitNonAccessingDescription: anObject
	self visitElementDescription: anObject! !

!MAVisitor methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 2/3/2008 22:26'!
visitSelectItemDescription: anObject
	self visitBooleanDescription: anObject! !

!MAFileModel class methodsFor: '*magritte-rdb' stamp: 'kph 1/14/2008 01:14'!
fromDBString: aString

	^ self new filename: aString; yourself! !

!MAFileModel methodsFor: '*magritte-rdb' stamp: 'kph 1/14/2008 01:09'!
asDBString

	^ self filename! !

!MAExternalFileModel class methodsFor: '*magritte-rdb' stamp: 'kph 1/14/2008 01:44'!
fromDBString: aString

	| parts |
	parts := aString splitOn: '/'.
	^ self new
	    setLocation: parts allButLast;
		filename: parts last; 
		yourself! !

!MAExternalFileModel methodsFor: '*magritte-rdb' stamp: 'kph 1/14/2008 01:41'!
asDBString

	^ (self location copyWith: self filename) joinUsing: $/
! !

!MAExternalFileModel methodsFor: '*magritte-rdb' stamp: 'kph 1/14/2008 01:44'!
setLocation: locArray
	location := locArray! !

TestCase subclass: #MAMySqlCoercionTests
	instanceVariableNames: 'query row1 result dict row2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MAMySqlCoercionTests class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:06'!
publishedSuites
	^super publishedSuites , #( #webStoreTests )! !

!MAMySqlCoercionTests class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:29'!
resource 

	^  MAMysqlTestResource ! !

!MAMySqlCoercionTests class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:29'!
resources

	^ Set with: self resource ! !

!MAMySqlCoercionTests class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:12'!
usesDatabase

^ self webStoreTests! !

!MAMySqlCoercionTests class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:06'!
webStoreTests

	^ self allStandardTests! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:29'!
db

	^ self class resource current databaseInterface! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 18:28'!
modelClass
 
	^ MACoercionTestModel ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 3/18/2009 00:30'!
query

	^ MAQuerySql table: self modelClass sqlTableName queryForModelClass: self modelClass
	 ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:50'!
setUp

	self db execute: 'DELETE FROM TESTING'! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2008 02:23'!
setUpQuery

	query :=  MAQuerySql modelClass: self modelClass.
	
	 ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:48'!
testFields
 
	self setUpQuery.
	
	self assert: (query selectFields asSortedCollection = #( 'TESTING.id' 'TESTING.password'  'TESTING.shortBool' 'TESTING.bool' 'TESTING.tokens' 'TESTING.price' 'TESTING.priceUsd')   asSortedCollection ).
 ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:03'!
testInsertExtFile
 
"
self debug: #testInsertExtFile.  
"
	self setUpQuery.
	 
	row1 := self modelClass new extFile: (MAExternalFileModel new filename: 'test'; setLocation: #('a' 'b'); yourself) .  
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
		
			self assert: ((resultSet rawValueNamed: 'extFile') = 'a/b/test').
	 
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:56'!
testInsertExtFiles
 
"
self debug: #testInsertExtFiles.  
"
	| one two list |
	self setUpQuery.
	 
	one := MAExternalFileModel new filename: 'test'; setLocation: #('a' 'b'); yourself.
	two := MAExternalFileModel new filename: 'test'; setLocation: #('c' 'd'); yourself.
	list := Array with: one with: two.
	
	row1 := self modelClass new extFiles: list.
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
		
			self assert: ((resultSet rawValueNamed: 'extFiles') = ('a/b/test',(Character value: 138) asString , 'c/d/test')).
	 
	].

	^ list! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 04:20'!
testInsertExtFilesEmpty
 
"
self debug: #testInsertExtFilesEmpty.  
"
	| |
	self setUpQuery.
	 
	row1 := self modelClass new extFiles: #().
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
		
			"should be an empty string".
			self assert: ((resultSet rawValueNamed: 'extFiles') = nil ). 
	].

	 ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:59'!
testInsertFalse
 
"
self debug: #testInsert. 
"
	self setUpQuery.
	 
	row1 := self modelClass new valueForRowFalse.
	
	self assert: row1 id isNil.
	 
	row1 storeNewOnDB.
	
	self assert: (row1 id notNil).
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet |
 	resultSet next.
	self assert: ((resultSet rawValueNamed: 'bool') = 'false').
	self assert: ((resultSet rawValueNamed: 'shortbool') = 'N')
	
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:08'!
testInsertNilValues
 
"
self debug: #testInsertNilValues. 
"
	self setUpQuery.
	 
	row1 := self modelClass new.
	
	self assert: row1 id isNil.
	 
	row1 storeNewOnDB.
	
	self assert: (row1 id notNil).
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet |
 	resultSet next.
	self assert: ((resultSet rawValueNamed: 'bool') = 'true').
	self assert: ((resultSet rawValueNamed: 'shortbool') = nil).
	self assert: ((resultSet rawValueNamed: 'password') = nil)
	
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:25'!
testInsertPassword
 
"
self debug: #testInsertPassword. 
"
	self setUpQuery.
	 
	row1 := self modelClass new password: 'mysecret'. 
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
	self assert: ((resultSet rawValueNamed: 'password') size = 41).
	 
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:46'!
testInsertPrice
 
"
self debug: #testInsertPrice. 
"
	self setUpQuery.
	 
	row1 := self modelClass new price: 23.4555.
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
	self assert: ((resultSet rawValueNamed: 'price') = '23.46').
	 
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:47'!
testInsertPriceUsd
 
"
self debug: #testInsertPriceUsd. 
"
	self setUpQuery.
	 
	row1 := self modelClass new priceUsd: 23.4555.
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
	self assert: ((resultSet rawValueNamed: 'priceUsd') = '23.46usd').
	 
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 10/20/2007 19:41'!
testInsertString
 
"
self debug: #testInsertString. 
"
	self setUpQuery.
	 
	row1 := self modelClass new.
	row1 string: 'test string'.
	
	self assert: row1 id isNil.
	 
	row1 storeNewOnDB.
	
	self assert: (row1 id notNil).
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet |
 	resultSet next.
	self assert: ((resultSet rawValueNamed: 'string') = 'test string').
	
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 04:18'!
testInsertStringEmpty
 
"
self debug: #testInsertStringEmpty. 
"
	self setUpQuery.
	 
	row1 := self modelClass new.
	row1 string:  ''.
	
	self assert: row1 id isNil.
	 
	row1 storeNewOnDB.
	
	self assert: (row1 id notNil).
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet |
 	resultSet next.
	"I would like it to be '' but the driver cant tell between Null and '' for string fields"
	self assert: ((resultSet rawValueNamed: 'string') = nil).
	
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:43'!
testInsertTokens
 
"
self debug: #testInsertTokens. 
"
	self setUpQuery.
	 
	row1 := self modelClass new tokens: #('the' 'test' 'set'). 
	row1 storeNewOnDB.
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet | resultSet next.
	self assert: ((resultSet rawValueNamed: 'tokens') = 'the test set').
	 
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:58'!
testInsertTrue
 
"
self debug: #testInsert. 
"
	self setUpQuery.
	 
	row1 := self modelClass new valueForRowTrue.
	
	self assert: row1 id isNil.
	 
	row1 storeNewOnDB.
	
	self assert: (row1 id notNil).
	
	self db execute: ('SELECT * FROM TESTING WHERE id = ', row1 id asString)
	
		with: [ :resultSet |
 	resultSet next.
	self assert: ((resultSet rawValueNamed: 'bool') = 'true').
	self assert: ((resultSet rawValueNamed: 'shortbool') = 'Y')
	
	].! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:08'!
testReadExtFile
 
"
self debug: #testReadExtFile 
"
	self testInsertExtFile.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 extFile asDBString = 'a/b/test'! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:59'!
testReadExtFiles
 
"
self debug: #testReadExtFiles  
"
	| list |
	list := self testInsertExtFiles.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 extFiles = list! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 04:21'!
testReadExtFilesEmpty
 
"
self debug: #testReadExtFilesEmpty  
"
	self testInsertExtFilesEmpty.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 extFiles = #()! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:00'!
testReadFalse
 
"
self debug: #testReadFalse. 
"
	self testInsertFalse.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 id isInteger.
	self deny: row1 bool.
	self deny: row1 shortBool. 
 ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:09'!
testReadNilValues
 
"
self debug: #testReadNilValues. 
"
	self testInsertNilValues.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 id isInteger.
	self assert: row1 bool.
	self assert: row1 shortBool isNil. 
 ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 2/1/2008 20:43'!
testReadString
"
self debug: #testReadString 
"
	self testInsertString.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 string = 'test string'! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 20:47'!
testReadTokens
 
"
self debug: #testReadTokens. 
"
	self testInsertTokens.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 tokens = #('the' 'test' 'set').
  ! !

!MAMySqlCoercionTests methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 19:59'!
testReadTrue
 
"
self debug: #testRead. 
"
	self testInsertTrue.
	 
	row1 := self modelClass realizeAll first.
	
	self assert: row1 id isInteger.
	self assert: row1 bool.
	self assert: row1 shortBool. 
 ! !

TestCase subclass: #MAMySqlTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MAMySqlTestCase class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:22'!
resource 

	^  MAMysqlTestResource ! !

!MAMySqlTestCase class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:22'!
resources

	^ Set with: self resource ! !

!MAMySqlTestCase class methodsFor: 'as yet unclassified' stamp: 'kph 9/20/2007 22:22'!
usesDatabase

^ self allStandardTests! !

Object subclass: #MAModel
	instanceVariableNames: 'insertOrUpdate properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

MAModel class
	instanceVariableNames: 'cache'!

!MAModel commentStamp: 'kph 2/1/2008 19:48' prior: 0!
Within the model

	self context returns the current context or null.
	Normally there should be a current context so there is nothing unusual.
	
properties - used for ui to indicate selection.!

MAModel class
	instanceVariableNames: 'cache'!

!MAModel class methodsFor: 'sql' stamp: 'kph 8/20/2007 12:00'!
addSortersTo: list

^ list! !

!MAModel class methodsFor: 'sql' stamp: 'kph 1/31/2008 21:15'!
availableQualifiers

	^ (self class allSelectorsBelow: Object class) select: [ :each | each beginsWith: #sqlQualifier ] 
	
"
WSProductData availableQualifiers

"! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 06:38'!
cacheClear
 
	cache := nil! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 06:37'!
cachedAll 
 
	^ cache ifNil: [ cache := self realizeAll ]
	! !

!MAModel class methodsFor: 'as yet unclassified' stamp: 'kph 9/12/2007 18:59'!
canAddNewRecord
	^ false! !

!MAModel class methodsFor: 'sql' stamp: 'kph 10/5/2007 00:34'!
context
	^ PRCurrentContext value! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/18/2009 01:38'!
createTable

	^  self rdbTable createTable
! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/30/2009 16:46'!
databaseInterface
 
	^ self site db dbSession! !

!MAModel class methodsFor: 'sql' stamp: 'kph 10/22/2008 22:31'!
description

	^ super description
		pointTo: self sqlTableName;
		collect: [:description | description pointTo: self sqlTableName]! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 23:00'!
descriptionActionEdit
 
	self isRecordEditable ifFalse: [ ^ nil ].

	^ (MAButtonDescription new)
		actionAccessor: #doActionEdit ;
		label: '(edit)';
		comment: 'Edit Item';
		propertyAt: #hasValue put: false;
		propertyAt: #isEditable put: false;
		beReadonly;
		priority: 30;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 23:00'!
descriptionActionRemove

	self isRecordDeletable ifFalse: [ ^ nil ].

	^ (MAButtonDescription new)
		actionAccessor: #doActionRemove ;
		propertyAt: #hasValue put: false;
		propertyAt: #suUpdateOnClick put: true;
		label: '(remove)';
		comment: 'Delete Item';
		beReadonly;
		priority: 30;
		yourself! !

!MAModel class methodsFor: 'as yet unclassified' stamp: 'kph 2/3/2008 22:24'!
descriptionSelected

	self isRecordSelectable ifFalse: [ ^ nil ].
	
	^ (MASelectItemDescription new)
		selectorAccessor: #selected;
		label: 'Select';
	    yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 2/3/2008 17:50'!
doActionAdd: widget
	 
	widget appendEmptyRecord: nil! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 2/3/2008 17:18'!
doActionRemove: widget

	(widget items select: [ :i | i selected ]) do: [ :i | i doActionRemove: widget ]! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 22:15'!
dropTable

	^   [ self databaseInterface execute: self sqlDropTable ] ifError: []
! !

!MAModel class methodsFor: 'sql' stamp: 'kph 8/15/2007 13:42'!
filterNone: items

	^ items! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 06:38'!
freeSomeSpace
	
	self cacheClear! !

!MAModel class methodsFor: 'model descriptions' stamp: 'kph 8/18/2007 15:00'!
getDescriptionForInsert
	^ self description select: [ :d | d isPersisted ]! !

!MAModel class methodsFor: 'model descriptions' stamp: 'kph 8/10/2007 13:38'!
getDescriptionNamed: aString 
	^ (self 
		perform: (self class allSelectors detect: 
					[:selector | 
					selector isDescriptionSelector 
						and: [selector endsWith: aString]])) 
			pointTo: self sqlTableName! !

!MAModel class methodsFor: 'model descriptions' stamp: 'kph 10/15/2007 01:54'!
getModelDescription
	^ MAToOneRelationDescription new 
		autoAccessor: self label asLowercase; 
		label: self label;
		classes: (Array with: self);
		componentClass: MAInternalEditorComponent;
		default: self new;
		yourself! !

!MAModel class methodsFor: 'convenience' stamp: 'dc 11/25/2005 06:04'!
getSelectDescription
	| collection |
	collection := self getValues.
	^(MASingleOptionDescription auto: self label asLowercase label: self label)
		options: collection;
		default: collection first;
		fieldName: self label asLowercase;
		reference: GIAssociationDescription new;
		beRequired;
		beWithId;
		yourself! !

!MAModel class methodsFor: 'sql' stamp: 'kph 8/14/2007 17:40'!
getSqlWhere
	^ self sqlWhere
		ifEmpty: ['']
		ifNotEmpty: [ ' WHERE ', self sqlWhere ].! !

!MAModel class methodsFor: 'sql' stamp: 'kph 9/12/2007 17:52'!
getValues
	^self databaseInterface 
		getNamesCollectionFrom: 'SELECT ' , self sqlTableName , '.' , self sqlId 
				, ' AS Id, ' , self sqlDisplayedNameForSelection 
				, '  As Name FROM ' , self sqlTableName 
				, ' ' , self sqlJoin 
				, self getSqlWhere! !

!MAModel class methodsFor: 'testing' stamp: 'dc 11/6/2005 17:14'!
isAbstract
	^ true! !

!MAModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/4/2007 06:00'!
isRecordAddable
	^ false! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 9/6/2007 22:19'!
isRecordDeletable

	^ false! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 9/6/2007 22:19'!
isRecordEditable

	^ false! !

!MAModel class methodsFor: 'as yet unclassified' stamp: 'kph 9/12/2007 18:57'!
isRecordSelectable 

	^ false! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/22/2007 02:00'!
mgViewActions
	"we definitely do not want the cached version so use #build: instead of #for:"
	^ (MACustomDescriptionBuilder prefix: #mgViewActions) build: self! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 23:00'!
mgViewActionsAdd
 
	self isRecordAddable ifFalse: [ ^ nil ].
	
	^ (MAButtonDescription new)
		actionAccessor: #doActionAdd;
		propertyAt: #suUpdateOnClick put: true;
		label: 'Add New ', self typeLabel;
		comment: 'Add New ', self typeLabel;
		beReadonly;
		priority: 30;
		yourself  
 
 ! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 22:59'!
mgViewActionsAutoAppendEmptyRecord
 
	self isRecordAddable ifFalse: [ ^ nil ].
	
	^ (MAActionDescription new)
		selectorAccessor: #dummy;
		propertyAt: #initializeItems put: #appendEmptyRecord: ;
		label: 'Auto Append Empty Record';
		priority: 35;
		yourself  
 ! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 23:00'!
mgViewActionsRemove
 
	(self isRecordDeletable and: [ self isRecordSelectable ]) ifFalse: [ ^ nil ].
	
	^ (MAButtonDescription new)
		actionAccessor: #doActionRemove;
		propertyAt: #suUpdateOnClick put: true;
		label: 'Remove';
		comment: 'Remove Selected ', self typeLabelPlural;
		beReadonly;
		priority: 30;
		yourself  
 ! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 22:59'!
mgViewActionsUseMultipartForm
  	
	^ (MAActionDescription new)
		selectorAccessor: #dummy2;
		propertyAt: #initializeItems put: #makeMultipart ;
		label: 'Use Multipart Form';
		comment: 'Multipart form for file uploads';
		priority: 30;
		yourself  
 ! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/22/2007 04:21'!
mgViewAvailableActions

	^  self mgViewActions children asArray
! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 2/10/2009 14:20'!
mgViewAvailableFields

	^ (MAQueryModel modelClass: self) 
			performQuery selectDescriptions select: [ :d | (d isVisible | d isAvailable) ]
		
	 ! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 3/19/2009 23:00'!
mgViewAvailableFieldsAndSpacers

	^  self mgViewAvailableFields addAll: (MADividerDescription availableSpacers); yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/19/2007 03:36'!
mgViewAvailableFilters

	^ (self class allSelectorsBelow: Object class) select: [ :each | each beginsWith: #filter ] 
	
! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 10/17/2007 06:47'!
mgViewAvailableQualifiers

	^ (self class allSelectorsBelow: Object class) select: [ :each | each beginsWith: #sqlQualifier ] 
	
"
WSProductData availableQualifiers

"! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/20/2007 02:23'!
mgViewSettings
	"we definitely do not want the cached version so use #build: instead of #for:"
	^ (MACustomDescriptionBuilder prefix: #mgViewSettings) build: self! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/22/2007 04:25'!
mgViewSettingsActions
	^ (MAMultipleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #actions));
		label: 'Actions';
		priority: 200;
		options: [ self mgViewAvailableActions ] asDynamicObject;    
		default: #();
		reference: MADescriptionDescription new;
		componentClass: MACheckboxGroupComponent ;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/20/2007 15:47'!
mgViewSettingsEditableFields
	^ (MAMultipleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #editableFields));
		label: 'Editable Fields';
		priority: 120;
		options: [ self mgViewAvailableFields select: [ :d | d isReadonly not ] ] asDynamicObject;
		default: #();
		reference: MADescriptionDescription new;
		componentClass: MACheckboxGroupComponent ;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/20/2007 16:30'!
mgViewSettingsFilter
	^ (MASingleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #filter));
		label: 'Filter';
		priority: 100;
		default: #filterNone: ;
		options: [ self mgViewAvailableFilters ] asDynamicObject;
		beRequired;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/21/2007 15:55'!
mgViewSettingsLabelledFields
	^ (MAMultipleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #labelledFields));
		label: 'Labelled Fields';
		priority: 125;
		options: [ self mgViewAvailableFields  ] asDynamicObject;
		default: #();
		reference: MADescriptionDescription new;
		componentClass: MACheckboxGroupComponent ;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 9/6/2007 22:08'!
mgViewSettingsQualifier
	^ (MASingleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #qualifier));
		label: 'Qualifier';
		priority: 100;
		options: [ self mgViewAvailableQualifiers ] asDynamicObject;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 8/20/2007 16:31'!
mgViewSettingsSorters
	^ (MAMultipleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #sorters));
		label: 'Sorters';
		priority: 200;
		options: [ self sorters keys ] asDynamicObject;
		default: [ #() ] asDynamicObject;
		componentClass: MACheckboxGroupComponent ;
		yourself! !

!MAModel class methodsFor: 'settings descriptions' stamp: 'kph 10/13/2007 14:06'!
mgViewSettingsVisibleFieldOrder
	^ (MAMultipleOptionDescription new)
		accessor: (MAChainAccessor accessor: (MASelectorAccessor selector: #properties) next: (MADictionaryAccessor key: #visibleFieldOrder));
		label: 'Fields';
		priority: 100;
		options: [ self mgViewAvailableFieldsAndSpacers ] asDynamicObject;
		default: #() ;
		reference: MADescriptionDescription new;
		componentClass: MAListCompositonComponentSU;
		beRequired;
		beOrdered;
		yourself! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/22/2009 22:06'!
newRecord

	^ self new 	
		beInsertNeeded;
		initializeNewAddedRecord; 
		yourself! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/23/2009 02:37'!
newToReadInto

	^ self new initializeForRead; yourself! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/18/2009 00:30'!
query

	^ self databaseInterface table: self sqlTableName queryForModelClass: self! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/18/2009 01:20'!
rdbTable

	^ self rdbTableClass
			setSqlTableName: self sqlTableName;
			setModelClass: self;
			yourself! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/18/2009 01:18'!
rdbTableClass

	^ MATableRDB
! !

!MAModel class methodsFor: 'sql' stamp: 'kph 9/13/2007 01:37'!
realizeAll 
 
	^ self realizeAllForSqlWhere: ''
	 
	! !

!MAModel class methodsFor: 'sql' stamp: 'kph 12/7/2007 05:08'!
realizeAllForQualifier: selector inContext: context
 
	^ self perform: (selector ifNil: [ #sqlQualifierAll: ]) asSymbol with: context! !

!MAModel class methodsFor: 'sql' stamp: 'kph 10/16/2007 19:41'!
realizeAllForSqlWhere: conditions 
 
	^ (self query sqlWhere: conditions; yourself) performQuery.
	
	! !

!MAModel class methodsFor: 'sql' stamp: 'kph 8/20/2007 10:50'!
sorters

	^ self addSortersTo: Dictionary new! !

!MAModel class methodsFor: 'sql' stamp: 'kph 3/18/2009 01:21'!
sqlCreateTable

	^ self rdbTable sqlCreateTable
	

! !

!MAModel class methodsFor: 'sql' stamp: 'dc 12/24/2005 15:08'!
sqlDisplayedNameForSelection
	^ self subclassResponsibility! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 22:14'!
sqlDropTable

	^  'DROP TABLE  ', self sqlTableName

! !

!MAModel class methodsFor: 'sql' stamp: 'kph 8/13/2007 15:41'!
sqlFieldRef: fieldName
	^ self sqlTableName, '.', fieldName! !

!MAModel class methodsFor: 'sql' stamp: 'dc 11/15/2005 06:44'!
sqlId
	^ self subclassResponsibility ! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 11:45'!
sqlIndexDefinitions
	^ OrderedCollection new! !

!MAModel class methodsFor: 'sql' stamp: 'dc 11/19/2005 18:22'!
sqlJoin
	^ ''! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/9/2007 20:56'!
sqlQualifierAll: context

	^ self realizeAll! !

!MAModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 11:05'!
sqlTableEngine
	^  'MyISAM'! !

!MAModel class methodsFor: 'sql' stamp: 'dc 12/24/2005 15:08'!
sqlTableName
	^ self label asUppercase! !

!MAModel class methodsFor: 'sql' stamp: 'dc 11/24/2005 17:26'!
sqlWhere
	^ ''! !

!MAModel class methodsFor: 'sql' stamp: 'kph 9/13/2007 13:41'!
typeLabel

^ 'Item'! !

!MAModel class methodsFor: 'sql' stamp: 'kph 9/13/2007 13:44'!
typeLabelPlural

^ 'Items'! !

!MAModel class methodsFor: 'sql' stamp: 'kph 8/15/2007 12:31'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!MAModel class methodsFor: 'sql' stamp: 'kph 8/15/2007 12:31'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!MAModel methodsFor: 'comparing' stamp: 'kph 10/13/2007 14:46'!
= aModel

	| a b |
	
	^ aModel species = self species and: 
		[ aModel description do: [:description | 
			a := (description accessor canRead: self) ifTrue: [ description accessor read: self ] ifFalse: [ description ].
			b := (description accessor canRead: aModel) ifTrue: [ description accessor read: aModel ] ifFalse: [ description ].
			(a == self and: [ b == self ]) ifFalse: [ a == b ifFalse: [ a = b ifFalse: [^ false]]] ].
		  ^ true ]! !

!MAModel methodsFor: 'sql' stamp: 'kph 8/21/2008 02:25'!
beInsertNeeded

	insertOrUpdate := #insert.
	self sqlOthers do: #beInsertNeeded  ! !

!MAModel methodsFor: 'sql' stamp: 'kph 8/21/2008 02:25'!
beUpdateNeeded
 
		insertOrUpdate ifNil:[ insertOrUpdate := #update ].
		self sqlOthers do: #beUpdateNeeded ! !

!MAModel methodsFor: 'events' stamp: 'kph 11/4/2008 14:55'!
cacheClear
 
	self class cacheClear.! !

!MAModel methodsFor: 'accessing' stamp: 'kph 3/30/2009 16:46'!
commit: aBlock

	aBlock value.

	^ self site autoCommit: self
	! !

!MAModel methodsFor: 'events' stamp: 'kph 10/5/2007 00:29'!
context
	^ PRCurrentContext value orNull! !

!MAModel methodsFor: 'memento' stamp: 'kph 11/20/2007 06:43'!
copyForRealMemento

	^ self shallowCopy postCopyForRealMemento ! !

!MAModel methodsFor: 'sql' stamp: 'kph 8/22/2008 01:21'!
db: querySql read: readBlock do: doBlock
	"Fetches the data from MySQL"
 
	self databaseInterface execute: querySql with: [ :aResultSet |

		[ aResultSet next  ] whileTrue: [ (readBlock value: aResultSet) ifNotNilDo: doBlock ].
	].
 ! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/15/2007 15:25'!
defaultRenderFor: widget on: html

	html render: self printString! !

!MAModel methodsFor: 'events' stamp: 'kph 11/4/2008 14:55'!
deleteFromDB
 
	(self isInsertNeeded not and: [ self isDataPresentForStoreOrDelete ])
			 ifTrue: [ self class databaseInterface execute: self sqlDelete  ].
 	
	self cacheClear! !

!MAModel methodsFor: 'events' stamp: 'kph 8/23/2007 01:17'!
doActionEdit: activeWidget

(activeWidget call: (self asComponent
	 	"addMessage: 'Edit ' , self selected label;"
		addValidatedForm;
		yourself)) ifNotNilDo: [ :savedInstance | savedInstance storeOnDB ]
! !

!MAModel methodsFor: 'events' stamp: 'kph 2/3/2008 17:50'!
doActionRemove: activeWidget
	activeWidget markDirty.
	self deleteFromDB
 	
! !

!MAModel methodsFor: 'events' stamp: 'kph 8/22/2007 04:58'!
dummy

 ^ 'dummy'! !

!MAModel methodsFor: 'events' stamp: 'kph 8/22/2007 04:58'!
dummy: d
! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/14/2007 17:45'!
getSqlWhere
	^ self sqlWhere
		ifEmpty: ['']
		ifNotEmpty: [ ' WHERE ', self sqlWhere ].! !

!MAModel methodsFor: 'events' stamp: 'kph 3/23/2009 02:37'!
initializeForRead

! !

!MAModel methodsFor: 'events' stamp: 'kph 3/22/2009 22:06'!
initializeNewAddedRecord

! !

!MAModel methodsFor: 'events' stamp: 'kph 10/4/2007 14:33'!
isDataPresentForStoreOrDelete
	"test before storing data, here to ovoid commiting empty records etc."
	^ true! !

!MAModel methodsFor: 'sql' stamp: 'kph 9/4/2007 13:33'!
isInsertNeeded

	^ insertOrUpdate = #insert ! !

!MAModel methodsFor: 'testing' stamp: 'kph 2/4/2008 14:04'!
isMAModel
	^ true! !

!MAModel methodsFor: 'sql' stamp: 'kph 9/4/2007 13:35'!
isStoreNeeded

	^ insertOrUpdate notNil! !

!MAModel methodsFor: 'accessing-properties' stamp: 'dc 11/25/2005 05:58'!
label
	^ self class label! !

!MAModel methodsFor: 'events' stamp: 'kph 10/23/2007 00:21'!
postCommit

	insertOrUpdate := nil.
	self sqlOthers do: [ :each | each postCommit ].! !

!MAModel methodsFor: 'memento' stamp: 'kph 11/20/2007 06:44'!
postCopyForRealMemento 

	^ self! !

!MAModel methodsFor: 'events' stamp: 'kph 1/25/2008 13:16'!
postRealize
	self sqlOthers do: [ :each | each postRealize ].! !

!MAModel methodsFor: 'sql' stamp: 'kph 9/12/2007 21:51'!
postRealizeStoreIfNeeded
 
	self isStoreNeeded ifTrue: [ self storeOnDB ].! !

!MAModel methodsFor: 'events' stamp: 'kph 8/21/2008 02:17'!
preStore.
! !

!MAModel methodsFor: 'accessing-properties' stamp: 'kph 2/3/2008 17:18'!
propertyAt: key ifAbsent: aBlock

	properties ifNil: [ ^ aBlock value ].
	
	^ properties at: key ifAbsent: aBlock! !

!MAModel methodsFor: 'accessing-properties' stamp: 'kph 2/1/2008 19:48'!
propertyAt: key put: value

	properties ifNil: [ properties := Dictionary new ].
	
	^ properties at: key put: value.! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/15/2007 15:48'!
renderDefaultFor: widget on: html

	html render: self printString! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/17/2007 16:26'!
renderDisplayStringFor: widget on: html

	html render: self displayString! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/15/2007 15:49'!
renderShortFor: widget on: html

	html render: self printString! !

!MAModel methodsFor: 'events' stamp: 'kph 2/3/2008 17:15'!
selected
  
 ^ (self propertyAt: #selected ifAbsent: false) = true! !

!MAModel methodsFor: 'events' stamp: 'kph 2/3/2008 17:13'!
selected: bool
	 
	self propertyAt: #selected put: bool ! !

!MAModel methodsFor: 'sql' stamp: 'kph 9/26/2007 15:46'!
sqlDelete  

	^ 'DELETE FROM ', self class sqlTableName , self getSqlWhere
! !

!MAModel methodsFor: 'validation' stamp: 'kph 9/26/2007 15:46'!
sqlDeletes
	
	| ui |
	
	ui := self sqlDelete.
	
	ui isEmptyOrNil ifTrue: [ ^ #() ].
	
	^ Array with: ui! !

!MAModel methodsFor: 'sql' stamp: 'kph 9/12/2007 17:51'!
sqlFields
	^ self class databaseInterface  getFieldsFromDescriptionOn: self! !

!MAModel methodsFor: 'sql' stamp: 'kph 8/14/2007 19:00'!
sqlInsert
	^' INSERT INTO ' , self class sqlTableName , ' SET ' , self sqlFields! !

!MAModel methodsFor: 'validation' stamp: 'kph 10/23/2007 00:08'!
sqlMyUpdates
	
	| ui |
	
	self isDataPresentForStoreOrDelete ifFalse: [ ^ #() ].
	
	ui := self isInsertNeeded ifTrue: [ self sqlInsert ] ifFalse: [ self sqlUpdate ].
	
	ui isEmptyOrNil ifTrue: [ ^ #() ].
	
	^ Array with: ui! !

!MAModel methodsFor: 'validation' stamp: 'kph 12/20/2007 14:37'!
sqlOtherUpdates
	
	^ self sqlOthers gather: [ :each | each ifNil: [#() ]ifNotNil: [ each sqlUpdates ] ]! !

!MAModel methodsFor: 'validation' stamp: 'kph 10/23/2007 00:14'!
sqlOthers
	
	^ OrderedCollection new! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/14/2007 17:41'!
sqlUpdate
	^' UPDATE ' , self class sqlTableName , ' SET ' , self sqlFields , self getSqlWhere ! !

!MAModel methodsFor: 'validation' stamp: 'kph 10/22/2007 23:56'!
sqlUpdates

	^ self sqlMyUpdates, self sqlOtherUpdates! !

!MAModel methodsFor: 'validation' stamp: 'kph 8/10/2007 16:34'!
sqlWhere

	"refers to the row corresponding to this instance"
	
	^ ''! !

!MAModel methodsFor: 'events' stamp: 'kph 9/9/2008 15:01'!
storeNewOnDB

	^ self storeOnDB! !

!MAModel methodsFor: 'events' stamp: 'kph 3/23/2009 16:51'!
storeOnDB
	self preStore.
	self isDataPresentForStoreOrDelete ifFalse: [ ^ self ].
	self storeUpdatesOnDB: self sqlUpdates.! !

!MAModel methodsFor: 'sql' stamp: 'kph 3/23/2009 16:51'!
storeUpdatesOnDB: updates

	Preferences haltOnDbCommit ifTrue: [ self halt ].
	
	self class databaseInterface execute: (' ; ' useToJoin: updates).

	self class cacheClear.
	
	self postCommit.! !

!MAModel methodsFor: 'validation' stamp: 'dc 11/25/2005 06:02'!
throwMessage: aString
	GIModelError on: self message: aString! !

!MAModel methodsFor: 'validation' stamp: 'kph 2/4/2008 14:05'!
validate
	(self description select: [:description | description notNil and: [(description accessor read: self) isWAModel]])
		do: [:description | (description accessor read: self) validate]! !

MAModel subclass: #MANumberedModel
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MANumberedModel commentStamp: 'kph 3/11/2009 23:17' prior: 0!
We accept any object that magritte describes as a model. Thus the data model doesnt need to be designed with RDB in mind.!

MANumberedModel subclass: #MACoercionTestModel
	instanceVariableNames: 'bool shortBool password tokens price priceUsd string extFile extFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 01:53'!
databaseInterface

	^ MAMysqlTestResource current databaseInterface

! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 01:52'!
descriptionBool
	^MABooleanDescription new
		autoAccessor: 'bool';
		default: true;
		label: 'Bool';
		bePersisted;
		priority: 50;
		yourself! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 01:57'!
descriptionExtFile
	^MAFileDescription new
		kind: MAExternalFileModel;
		autoAccessor: 'extFile';
		label: 'External File';
		bePersisted;
		priority: 50;
		yourself! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 1/14/2008 02:57'!
descriptionExtFiles
	^MAMultipleOptionDescription new
		reference: (MAFileDescription new kind: MAExternalFileModel);
		autoAccessor: 'extFiles';
		label: 'External Files';
		bePersisted;
		priority: 50;
		yourself! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 01:52'!
descriptionPassword

	^ (MAPasswordDescription new)
		autoAccessor: 'password';
		bePersisted! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 01:52'!
descriptionPrice
	^MAPriceDescription new
		autoAccessor: 'price';
		bePersisted;
		yourself! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 01:52'!
descriptionPriceUsd
	^MAPriceDescription new
		autoAccessor: 'priceUsd';
		currency: #usd;
		bePersisted;
		yourself! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 01:52'!
descriptionShortBool

	^ (MABooleanDescription yn)
		autoAccessor: 'shortBool';
		bePersisted! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/20/2007 19:37'!
descriptionString

	^ (MAStringDescription new)
		autoAccessor: 'string';
		bePersisted! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 01:52'!
descriptionTokens
	^MATokenDescription new
		autoAccessor: 'tokens';
		label: 'Tokens';
		bePersisted;
		priority: 50;
		yourself! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 18:44'!
isAbstract

	^ false! !

!MACoercionTestModel class methodsFor: 'as yet unclassified' stamp: 'kph 7/25/2008 13:38'!
sqlTableName

	^ 'sq_TESTING'! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 8/16/2007 01:37'!
bool
	^ bool! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 8/16/2007 01:37'!
bool: anObject
	bool := anObject! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 1/14/2008 01:39'!
extFile
	"Answer the value of extFile"

	^ extFile! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 1/14/2008 01:39'!
extFile: anObject
	"Set the value of extFile"

	extFile := anObject! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 1/14/2008 02:13'!
extFiles
	"Answer the value of extFiles"

	^ extFiles! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 1/14/2008 02:13'!
extFiles: anObject
	"Set the value of extFiles"

	extFiles := anObject! !

!MACoercionTestModel methodsFor: 'accessing-generated' stamp: 'kph 9/13/2007 20:16'!
password
	^ password! !

!MACoercionTestModel methodsFor: 'accessing-generated' stamp: 'test 9/13/2007 20:21'!
password: anObject
	password := anObject! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 21:30'!
price
	"Answer the value of price"

	^ price! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 21:30'!
price: anObject
	"Set the value of price"

	price := anObject! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 21:43'!
priceUsd
	"Answer the value of priceUsd"

	^ priceUsd! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 21:43'!
priceUsd: anObject
	"Set the value of priceUsd"

	priceUsd := anObject! !

!MACoercionTestModel methodsFor: 'accessing-generated' stamp: 'kph 9/13/2007 18:45'!
shortBool
	^ shortBool! !

!MACoercionTestModel methodsFor: 'accessing-generated' stamp: 'kph 9/13/2007 18:51'!
shortBool: b
	 shortBool := b! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 10/20/2007 19:36'!
string
	"Answer the value of string"

	^ string! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 10/20/2007 19:36'!
string: anObject
	"Set the value of string"

	string := anObject! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 20:41'!
tokens
	"Answer the value of tokens"

	^ tokens! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 20:41'!
tokens: anObject
	"Set the value of tokens"

	tokens := anObject! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 19:58'!
valueForRowFalse

	"everything true"
	bool := false.
	shortBool := false.! !

!MACoercionTestModel methodsFor: 'accessing' stamp: 'kph 9/13/2007 19:58'!
valueForRowTrue

	"everything true"
	bool := true.
	shortBool := true.! !

MANumberedModel subclass: #MANamedModel
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MANamedModel class methodsFor: 'accessing-description' stamp: 'kph 8/18/2007 14:43'!
descriptionName
	^(MAStringDescription 
		selector: #name
		label: 'Name'
		priority: 10)
		beRequired;
		bePersisted;
		beUnique;
		yourself! !

!MANamedModel class methodsFor: 'sql' stamp: 'dc 12/24/2005 15:11'!
sqlDisplayedNameForSelection
	^ 'Name'! !

!MANamedModel methodsFor: 'validation' stamp: 'dc 11/25/2005 06:15'!
isAlreadyPresent: aString
	^ (self class getValues detect: [:assoc | assoc value = aString ] ifNone: [ nil ]) notNil
! !

!MANamedModel methodsFor: 'accessing' stamp: 'dc 12/24/2005 15:10'!
name
	^ name! !

!MANamedModel methodsFor: 'accessing' stamp: 'dc 12/24/2005 15:09'!
name: anObject
	name := anObject! !

!MANamedModel methodsFor: 'validation' stamp: 'dc 12/24/2005 16:33'!
validate
	super validate.
	(self class descriptionName isUnique 
		and: [self isAlreadyPresent: self name]) 
			ifTrue: [self throwMessage: 'Name should be unique']! !

!MANumberedModel class methodsFor: 'accessing-description' stamp: 'kph 11/18/2007 11:49'!
descriptionId
	^ (MANumberDescription selector: #id)
		label: 'id';
		propertyAt: #autoIncrement put: true;
	    beHidden;
		bePersisted;
	    yourself! !

!MANumberedModel class methodsFor: 'sql' stamp: 'kph 10/16/2007 19:43'!
realizeAllForId: id 

	^(self query where: (self description atField: #id) is: id) performQuery 
	! !

!MANumberedModel class methodsFor: 'sql' stamp: 'kph 10/14/2007 20:15'!
realizeForId: id 

	^ (self realizeAllForId: id) firstOrNil! !

!MANumberedModel class methodsFor: 'sql' stamp: 'dc 11/15/2005 13:21'!
sqlId
	^ 'Id'! !

!MANumberedModel class methodsFor: 'sql' stamp: 'kph 11/18/2007 11:47'!
sqlIndexDefinitions
	^  super sqlIndexDefinitions add: 'PRIMARY KEY (`id`)' ; yourself! !

!MANumberedModel methodsFor: 'accessing' stamp: 'dc 11/14/2005 20:06'!
id
	^ id! !

!MANumberedModel methodsFor: 'accessing' stamp: 'dc 11/14/2005 20:06'!
id: aNumber
	id := aNumber! !

!MANumberedModel methodsFor: 'sql' stamp: 'kph 10/5/2007 07:05'!
isDataPresentForStoreOrDelete
	"test before storing data, here to ovoid commiting empty records etc."
	^ id  notNil! !

!MANumberedModel methodsFor: 'sql' stamp: 'kph 10/22/2007 19:02'!
newId: anId

	self id: anId! !

!MANumberedModel methodsFor: 'sql' stamp: 'kph 8/10/2007 16:35'!
sqlWhere

	"refers to the row corresponding to this instance"
	
	^ ' id = ', id printString! !

!MANumberedModel methodsFor: 'sql' stamp: 'kph 3/23/2009 16:51'!
storeNewOnDB

	Preferences haltOnDbCommit ifTrue: [ self halt ].

	self class databaseInterface execute: self sqlInsert with: [:result | self newId: result value ].
	
	" #newId: needs to update the id field of any relations"	

	self storeUpdatesOnDB: self sqlOtherUpdates.
	
	! !

!MANumberedModel methodsFor: 'sql' stamp: 'kph 3/23/2009 16:51'!
storeOnDB

	Preferences haltOnDbCommit ifTrue: [ self halt ].

	self isDataPresentForStoreOrDelete ifFalse: [ ^ self ].

	id   ifNil: [ self storeNewOnDB ]
		ifNotNil: [ self storeUpdatesOnDB: self sqlUpdates ].

 ! !

Object subclass: #MATableRDB
	instanceVariableNames: 'sqlTableName dbSession modelClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MATableRDB commentStamp: 'kph 3/18/2009 01:49' prior: 0!
The beginnings of an RDB wrapper that is able to persist any Magritte model, using its descriptions.

We aim to be much the same as MAModel except that our actual model is pluggable and described via magritte.

!

!MATableRDB class methodsFor: 'as yet unclassified' stamp: 'kph 3/18/2009 02:34'!
engine

	^  'MyISAM'! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/22/2009 17:14'!
createForClass: aClass

	self setModelClass: aClass.

 	^ self dbSession execute: self sqlCreateTable
		! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/30/2009 16:46'!
dbSession

	^ dbSession ifNil: [ dbSession := self site db dbSession ]! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/18/2009 00:55'!
setDbSession: aDbSession
	"Set the value of sqlTable"

	dbSession := aDbSession! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/18/2009 01:15'!
setModelClass: mc

	modelClass := mc! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/17/2009 12:51'!
setSqlTableName: anObject
	"Set the value of sqlTable"

	sqlTableName := anObject! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/18/2009 02:34'!
sqlCreateTable

 	^ ((MASqlCreateTableVisitor modelClass: modelClass)
			setSqlTableName: sqlTableName;
			setEngine: self class engine;
			setDbSession: self dbSession;
			yourself) sqlCreateTable
		! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/18/2009 01:42'!
sqlFields
	^ self dbSession getFieldsFromDescriptionOn: self! !

!MATableRDB methodsFor: 'accessing' stamp: 'kph 3/18/2009 01:47'!
store: aModelInstance

	aModelInstance storeOnDB! !

Object subclass: #MYSQL41
	instanceVariableNames: 'connection spec dbWriter dbReader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MYSQL41 commentStamp: 'kph 9/12/2007 17:43' prior: 0!
Abstract superclass for higher level mysql database accessing.

Subclasses specify the particular database to be accessed!

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 8/22/2008 01:44'!
initialize

	Preferences addBooleanPreference: #dbLogQueries categories:  #('database') default: false balloonHelp: 'All database queries logged'.
  
	Preferences addBooleanPreference: #dbLogRows categories:  #('database') default: false balloonHelp: 'Log everything returned from a db query'.

	Preferences addBooleanPreference: #dbHaltOnCommit categories: #('database') default: false balloonHelp: 'Halt when write is made to database (if you have one)'. 
		
	Preferences addBooleanPreference: #dbIgnoreDatabase categories: #('database') default: false balloonHelp: 'All database queries return empty collection'.
  ! !

MYSQL41 subclass: #MYSQL40
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!MYSQL40 methodsFor: 'as yet unclassified' stamp: 'kph 7/3/2008 08:18'!
writeConverting: value on: stream

	JdmFactory40 instance fieldConverter convertToMysql: value on: stream
	
	! !

!MYSQL41 class methodsFor: 'convenience' stamp: 'kph 3/17/2009 12:45'!
connectionForUser: u password: p host: h database: d port: port timeout: t

	^ self new spec:
	
		(JdmConnectionSpec new initialize
			user: u;
			password: p;
			host: (NetNameResolver addressForName: h);
			database: d;
			port: port;
			timeout: t;
			yourself)
			
		yourself! !

!MYSQL41 class methodsFor: 'executing' stamp: 'kph 7/3/2008 06:52'!
execute: aSQLString
	
	"one shot queries which use a fresh db connection, and release that connection"
 
	^ self execute: aSQLString with: [:a | a ] ! !

!MYSQL41 class methodsFor: 'executing' stamp: 'kph 7/3/2008 06:50'!
execute: aSQLString with: aBlock
	
	"one shot queries which use a fresh db connection, and release that connection"
	| db |
	^ [ (db := self new) execute: aSQLString with: aBlock ] ensure: [ db closeConnection ]
	 ! !

!MYSQL41 class methodsFor: 'executing' stamp: 'kph 9/23/2008 12:11'!
maxNumberOfUpdates

	^ 100! !

!MYSQL41 class methodsFor: 'executing' stamp: 'kph 7/1/2008 19:11'!
openSession
	"if people want to provide/use an already open session we provide a hook here"
	^ self new! !

!MYSQL41 methodsFor: 'private' stamp: 'kph 3/17/2009 16:16'!
closeConnection
	connection ifNil: [ ^ nil ].
	connection close.
	connection := nil.! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
connection
	"Answer the value of connection"

	^ connection! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
connection: anObject
	"Set the value of connection"

	connection := anObject! !

!MYSQL41 methodsFor: 'private' stamp: 'kph 9/13/2007 18:01'!
connectionSpec

 	^ spec ifNil: [ self subclassResponsibility ]! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 8/22/2008 01:47'!
dbReader
 
	^ dbReader! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 8/22/2008 01:47'!
dbWriter
 
	^ dbWriter! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 11/18/2007 19:36'!
execute: aSQLString
	^ self execute: aSQLString with: [:a | a ] 
! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 8/22/2008 01:32'!
execute: querySql read: readBlock do: doBlock
	"Query utility for reading and coercing from MySQL, if read returns nil, do is ignored"
 	
	self execute: querySql with: [ :aResultSet |  
		
		[ aResultSet next  ] whileTrue: [ (readBlock value: aResultSet) ifNotNilDo: doBlock ].
	
	].
 ! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 3/23/2009 02:32'!
execute: sql readUsing: descriptions to: model do: doBlock

	self execute: sql
		read: [ :resultSet |   
			 
			dbReader coerce: resultSet using: descriptions to: model		 
				
		] 
		do: doBlock ! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 8/22/2008 01:42'!
execute: aSQLString with: aBlock
	"Execute aSQLString in a new connection and pass the result to aBlock"
	
	   | statement resultSet |
	 
		Preferences dbIgnoreDatabase ifTrue: [ ^ self ].
		aSQLString ifEmpty: [ ^ self ].
		
		Preferences dbLogQueries ifTrue: [ 
			self log dbQuery << 'connection:' << connection notNil << ' ' <<<  aSQLString.
		].
	
		self obtainConnection ensureAlive.

		statement := connection createStatement.
		[ resultSet := statement executeQuery: aSQLString ]
			on: self mysqlErrorClass do: [ :ex | connection := nil. self log dbError: ex printString. ex pass ].

		Preferences dbLogRows ifTrue: [ 
			self log dbQuery result: resultSet currentRow printString ].
	
		^ aBlock value: resultSet 
		
	 ! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 7/1/2008 19:19'!
getDescriptionsOn: aDescribedObject verifying: aBlock 
	"at present verification is performed against raw un-coerced model values"
	^ aDescribedObject class getDescriptionForInsert  select:
		[:description | description label notNil and:
			[aBlock  value: description value: (description accessor read: aDescribedObject)] ]
						! !

!MYSQL41 methodsFor: 'convenience' stamp: 'dc 11/8/2005 06:33'!
getDictionariesCollectionFrom: aSQLQuery
	|  tab |
	self execute: aSQLQuery 
		with: [:res | tab := OrderedCollection new.
				[ res next]
				whileTrue: [tab add: res currentRowAsDictionary]. ].
	
	^ tab! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 7/1/2008 19:24'!
getFieldsFromDescriptionOn: aDescribedObject 
	^ self  getFieldsFromDescriptionOn: aDescribedObject
		 verifying: [:description :value | true] ! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 7/1/2008 19:22'!
getFieldsFromDescriptionOn: aDescribedObject verifying: aBlock 
	^ self getFieldsFromDescriptionOn: aDescribedObject  verifying: aBlock  separatedBy: ' , '! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 3/29/2009 18:20'!
getFieldsFromDescriptionOn: aDescribedObject verifying: aBlock separatedBy: aString

	^ String  streamContents:
			[:stream | 
				(self getDescriptionsOn: aDescribedObject verifying: aBlock)
					do:	[:description | | table champ |
							table := description pointTo.
							champ := description getFieldName.
							stream nextPutAll: table; nextPut: $.; nextPutAll: champ;
								nextPutAll: '='.
								dbWriter coerce: aDescribedObject description: description on: stream  ]
					separatedBy:[stream  nextPutAll: aString]]! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 10/16/2007 19:28'!
getModelCollectionFrom: aSQLQuery model: aModelClass
	|  tab |
		"note this method doesnt coerce or anything like that"
	self execute: aSQLQuery 
		with: [:res | | row| tab := OrderedCollection new.
				[ (row := res nextAsDictionary) notNil ]
				whileTrue: [ | model |
					model := aModelClass new.
					row keysAndValuesDo: [:key :value | model perform: (key asLegalSelector,':') asSymbol 
																with:    value]. 
					tab add: model.]].
	^ tab
 ! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 10/16/2007 19:28'!
getModelCollectionFrom: aSQLQuery models: models 
	| tab |
	"note this method doesnt coerce or anything like that"
	self
		execute: aSQLQuery
		with: [:res | 
			| row | 
			tab := Dictionary new.
			[(row := res nextAsDictionary) notNil]
				whileTrue: [models
						do: [:modelClass | 
							| model | 
							model := (tab
										at: modelClass
										ifAbsentPut: [OrderedCollection new])
										add: modelClass new.
							row
								keysAndValuesDo: [:key :value | | selector | selector := (key asLegalSelector , ':') asSymbol.
													 (model respondsTo: selector)
												ifTrue: [model perform: selector with: value]]]]].
	^ tab! !

!MYSQL41 methodsFor: 'convenience' stamp: 'kph 7/1/2008 19:20'!
getNamesCollectionFrom: aSQLQuery
	^ (self getDictionariesCollectionFrom: aSQLQuery) collect: [:elem | (elem at: 'Id') -> (elem at: 'Name')]! !

!MYSQL41 methodsFor: 'private' stamp: 'kph 8/22/2008 01:38'!
initialize

	dbWriter := MAMySqlToDB client: self.
	dbReader := MAMySqlFromDB client: self.! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 8/9/2007 00:00'!
mysqlErrorClass

	^ Error! !

!MYSQL41 methodsFor: 'private' stamp: 'kph 7/3/2008 08:08'!
obtainConnection
 
	connection ifNil: [ 
		Socket initializeNetwork.
		connection := JdmConnection basicNew
			connectionSpec: self connectionSpec;
			yourself			
	].

	^ connection! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
spec
	"Answer the value of spec"

	^ spec! !

!MYSQL41 methodsFor: 'accessing' stamp: 'kph 9/13/2007 17:58'!
spec: anObject
	"Set the value of spec"

	spec := anObject! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 3/18/2009 00:29'!
table: sqlTableName queryForModelClass: aModelClass
	
	^ (MAQuerySql modelClass: aModelClass)
			setSqlTableName: sqlTableName
			yourself! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 12/20/2008 00:39'!
timeout

	^ 40! !

!MYSQL41 methodsFor: 'executing' stamp: 'kph 7/1/2008 19:49'!
writeConverting: value on: stream

	JdmFactory41 instance fieldConverter convertToMysql: value on: stream
	
	! !

MYSQL41 subclass: #MYSQLTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL-Tests'!

!MYSQLTester commentStamp: 'kph 9/13/2007 18:05' prior: 0!
Database for testing MySql!

!MYSQLTester methodsFor: 'connection spec' stamp: 'kph 1/14/2008 01:49'!
connectionSpec
 	"set the connection spec to your local test database"
	^ self connectionSpecLocal! !

!MYSQLTester methodsFor: 'connection spec' stamp: 'kph 1/14/2008 01:51'!
connectionSpecLocal
	 "set the connection spec to your local test database"
	^ JdmConnectionSpec new initialize
		user: 'seaside';
		password: 'seaside';
		host: #(127 0 0 1) asByteArray;
		database: 'test';
		port: 3306;
		 yourself
		
 ! !

!MYSQLTester methodsFor: 'connection spec' stamp: 'kph 1/14/2008 01:49'!
connectionSpecSeasideConfigSetting
 	"set the connection spec to your local test database"
	^ (Smalltalk at: #WAMySql) new connectionSpec! !

MYSQL41 subclass: #WAMySql
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!WAMySql commentStamp: 'kph 10/15/2007 00:26' prior: 0!
Seaside database access to MYSQL databases

This database connection spec is provided by the seaside configuration!

!WAMySql class methodsFor: 'as yet unclassified' stamp: 'kph 7/1/2008 19:13'!
openSession
	"if people want to provide/use an already open session we provide a hook here"
	^ WACurrentSession value properties at: #mysql ifAbsentPut: [ self new ]
		
		! !

!WAMySql methodsFor: 'private' stamp: 'kph 11/28/2007 17:16'!
connectionSpec

 	 ^ self connectionSpec: 'mysql'! !

!WAMySql methodsFor: 'private' stamp: 'kph 12/20/2008 00:43'!
connectionSpec: prefix

 	| app |

	app := WACurrentSession value application.

	^ JdmConnectionSpec new initialize
		user: ((app preferenceAt:  (prefix, 'User') asSymbol ) ifNil: [  ^ self error: 'MYSQL not configured for this application.']);
		
		password: (app preferenceAt: (prefix, 'Password') asSymbol );
		
		host: (NetNameResolver
				addressForName: (app preferenceAt: (prefix , 'Host') asSymbol) );
		
		database: (app preferenceAt: (prefix, 'Database') asSymbol);
		
		port: (app preferenceAt: (prefix, 'Port') asSymbol);
		
		timeout: self timeout;
		
		yourself! !

!WAMySql methodsFor: 'private' stamp: 'kph 12/20/2008 00:42'!
timeout

	^ 40! !

!Object methodsFor: '*magritte-rdb' stamp: 'kph 2/4/2008 14:05'!
isWAModel
	^ false! !

!MAPluggableAccessor class methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 3/19/2009 23:47'!
dummy

	^ self read: [ :model | ] write: [ :model :value | ]! !

WASystemConfiguration subclass: #WAMysqlConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-MySQL'!

!WAMysqlConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 00:28'!
attributes
	^ Array
		with: (WAStringAttribute key: #mysqlDatabase group: #mysql)
		with: (WAStringAttribute key: #mysqlUser group: #mysql)
		with: (WAPasswordAttribute key: #mysqlPassword group: #mysql)
		with: (WAStringAttribute key: #mysqlHost group: #mysql)
		with: (WANumberAttribute key: #mysqlPort group: #mysql)
		
! !

!WAMysqlConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 00:28'!
mysqlDatabase

	^ 'seaside'! !

!WAMysqlConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 00:28'!
mysqlHost

	^ 'localhost'! !

!WAMysqlConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 00:28'!
mysqlPassword

	^ 'seaside'! !

!WAMysqlConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 00:28'!
mysqlPort

	^ 3306! !

!WAMysqlConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 00:28'!
mysqlUser

	^ 'seaside'! !

!MABooleanDescription class methodsFor: '*magritte-rdb' stamp: 'kph 9/13/2007 19:06'!
yn

^ self new 
	trueString: 'Y';
	falseString: 'N';
	yourself! !

!MABooleanDescription methodsFor: '*magritte-rdb' stamp: 'kph 9/13/2007 21:07'!
dbRead: model
 
	"this hook provides a place for description types to map their values into and out of the db"
	^ self toString: (((self accessor read: model) ifNil: [ self default ]) ifNil: [ ^ nil ])! !

!MABooleanDescription methodsFor: '*magritte-rdb' stamp: 'kph 9/13/2007 20:53'!
dbWrite: value to: model

	^ super dbWrite: (value ifNil: [ self default ] ifNotNil: [ value asLowercase ]) to: model
	 ! !

MABooleanDescription subclass: #MASelectItemDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-Descriptions'!

!MASelectItemDescription class methodsFor: 'as yet unclassified' stamp: 'kph 2/3/2008 22:25'!
visitMagritte: aVisitor

	aVisitor visitSelectItemDescription: self! !

MANumberDescription subclass: #MAPriceDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB'!

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 03:50'!
acceptMagritte: aVisitor
	aVisitor visitPriceDescription: self! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:37'!
currency 
	^ self propertyAt: #currency ifAbsent: nil ! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 04:10'!
currency: aSymbol

	self propertyAt: #currency put: aSymbol! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 1/17/2008 22:12'!
currencySymbol

	^ self perform: (self propertyAt: #currency ifAbsent: #usd)! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/13/2007 21:46'!
dbWrite: value to: model
	^ super dbWrite: (value ifNotNil: [ value asFixedDecimal: 2]) to: model
 ! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 04:09'!
euro

	^ ''! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 04:09'!
ukp

	^ ''! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 04:08'!
usd

	^ '$'! !

!MAPriceDescription methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 04:09'!
yen

	^ ''! !

!MAMagnitudeDescription methodsFor: '*magritte-rdb' stamp: 'kph 9/13/2007 19:52'!
dbRead: model

	"this hook provides a place for description types to map their values into and out of the db"
	^ self accessor read: model! !

!MAMagnitudeDescription methodsFor: '*magritte-rdb' stamp: 'kph 9/13/2007 19:53'!
dbWrite: value to: model

	"this hook provides a place for description types to map their values into and out of the db"
	^ self accessor write: value to: model! !

!MAContainer methodsFor: '*magritte-rdb' stamp: 'kph 8/14/2007 02:24'!
atField: fieldName
	^ self detect: [ :desc | desc getFieldName = fieldName ]! !

!MADescription class methodsFor: '*magritte-rdb' stamp: 'kph 3/18/2009 01:54'!
defaultWithId

	^ false! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/25/2005 06:19'!
beNotUnique
	self unique: false! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 10/5/2007 05:56'!
bePersistOnChange

	self propertyAt: #persistOnChange put: true! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 8/18/2007 14:36'!
bePersisted
	self persisted: true! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/25/2005 06:19'!
beUnique
	self unique: true! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/8/2005 11:41'!
beWithId
	self withId: true! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 9/18/2007 13:02'!
dbWrite: value to: model

	"this hook provides a place for description types to map their values into and out of the db"
	^ self accessor write: (value ifNil:[ self default yourself ] ifNotNil: [ self fromString: value ]) to: model! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/9/2005 21:17'!
fieldName	
	^ self propertyAt: #fieldName ifAbsent: nil.! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/9/2005 21:14'!
fieldName: aString
	self propertyAt: #fieldName put: aString! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 8/13/2007 16:30'!
fieldRef

	^ self pointTo , '.', self getFieldName ! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 6/19/2008 22:47'!
getFieldName
	self isPersisted ifFalse: [ ^ nil ].
	self fieldName isNil
		ifFalse: [ ^ self fieldName ]
		ifTrue: [ self isWithId 
					ifTrue: [ ^ 'Id' ]
					ifFalse: [ ^ self accessor key ]]			! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 10/5/2007 05:55'!
isPersistOnChange

	^ self propertyAt: #persistOnChange ifAbsent: false! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 8/18/2007 14:36'!
isPersisted
	^ self persisted! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/25/2005 06:18'!
isUnique
	^ self unique! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/8/2005 11:41'!
isWithId
	^ self withId! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 9/11/2007 21:17'!
joinField	
	^ self propertyAt: #joinField ifAbsent: nil! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 9/11/2007 21:18'!
joinField: aString
	self propertyAt: #joinField put: aString! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 8/20/2007 12:43'!
persisted	
	^ self propertyAt: #persisted ifAbsent: [ false ].! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 8/18/2007 14:35'!
persisted: bool
	self propertyAt: #persisted put: bool! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/9/2005 13:30'!
pointTo	
	^ self propertyAt: #pointTo ifAbsent: ''.! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/9/2005 21:14'!
pointTo: aString 
	self  propertyAt:#pointTo  put:aString! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'kph 8/19/2007 16:18'!
type

	^ (self class  name allButFirst: 2)  readStream upToAll: 'Description'
	
! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/25/2005 06:18'!
unique	
	^ self propertyAt: #unique ifAbsent: [ self class defaultUnique ].! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/25/2005 06:18'!
unique: aBoolean	
	self propertyAt: #unique put: aBoolean.! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/25/2005 06:18'!
withId	
	^ self propertyAt: #withId ifAbsent: [ self class defaultWithId ].! !

!MADescription methodsFor: '*magritte-rdb' stamp: 'dc 11/8/2005 11:38'!
withId: aBoolean	
	self propertyAt: #withId put: aBoolean.! !

MADescription subclass: #MANonAccessingDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-Descriptions'!

!MANonAccessingDescription commentStamp: 'kph 3/19/2009 22:56' prior: 0!
These descriptions provide additional features for MAModel objects in tables, e.g.

1. Add an action link/button for each object e.g. (edit)
2. Add an action for the whole table e.g. (Add New Item)
3. Dividers!

MANonAccessingDescription subclass: #MAActionDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-Descriptions'!

!MAActionDescription class methodsFor: 'as yet unclassified' stamp: 'kph 10/3/2007 05:45'!
isAbstract

	^ false! !

MANonAccessingDescription subclass: #MAButtonDescription
	instanceVariableNames: 'actionAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-Descriptions'!

!MAButtonDescription class methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2007 02:38'!
isAbstract

	^ false! !

!MAButtonDescription methodsFor: 'as yet unclassified' stamp: 'kph 8/22/2007 04:37'!
acceptMagritte: aVisitor
	aVisitor visitButtonDescription: self! !

!MAButtonDescription methodsFor: 'accessing' stamp: 'kph 8/22/2007 04:52'!
actionAccessor
	^ actionAccessor! !

!MAButtonDescription methodsFor: 'accessing' stamp: 'kph 10/15/2007 02:03'!
actionAccessor: anObject
	anObject isSymbol ifTrue: [ ^ actionAccessor :=  MASelectorAccessor selector: anObject ].
	
	actionAccessor := anObject! !

!MAButtonDescription methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 02:36'!
actionOn: anItem in: widget 
	
	actionAccessor write: widget to: anItem
	
! !

!MAButtonDescription methodsFor: 'as yet unclassified' stamp: 'kph 10/31/2007 03:05'!
isButton

	^ true! !

MANonAccessingDescription subclass: #MADividerDescription
	instanceVariableNames: 'spacer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-RDB-Descriptions'!

!MADividerDescription commentStamp: 'kph 1/31/2008 19:59' prior: 0!
THIS CLASS HAS NO COMMENT!!
!

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 23:37'!
availableSpacers

	^ (self class selectors select: [ :each | each beginsWith: #spacer ]) collect: [ :each | self perform: each ] 
! !

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 9/25/2007 16:14'!
isAbstract

^ false! !

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 21:24'!
spacerBreak

^ self new
	spacer: #break;
	label: '(new line)';
	yourself! !

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 21:25'!
spacerClear

^ self new
	spacer: #clear;
 	label: '(clear)';
	yourself! !

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 21:25'!
spacerColumn

^ self new
	spacer: #column;
	label: '(--column--)';
	yourself! !

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 21:26'!
spacerRule

^ self new
 	spacer: #horizontalRule;
	label: '(--rule--)';
	yourself! !

!MADividerDescription class methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 21:26'!
spacerTableRow

^ self new
	spacer: #row;
	label: '(--row--)';
	yourself! !

!MADividerDescription methodsFor: 'accessing' stamp: 'kph 3/19/2009 23:43'!
acceptMagritte: aVisitor

	aVisitor visitDividerDescription: self! !

!MADividerDescription methodsFor: 'accessing' stamp: 'kph 1/31/2008 19:58'!
cssClasses

	^ self propertyAt: #cssClasses ifAbsent: [ Array with: self spacer ]
	
! !

!MADividerDescription methodsFor: 'accessing' stamp: 'kph 10/13/2007 17:20'!
initialize

	self propertyAt: #hasValue put: false.
	self beReadonly.! !

!MADividerDescription methodsFor: 'accessing' stamp: 'kph 1/31/2008 19:54'!
renderOn: html

	self spacer = #horizontalRule ifTrue: [ html horizontalRule ].
	self spacer = #break ifTrue: [ html break ].
	self spacer = #clear ifTrue: [  ].
	self spacer = #column ifTrue: [  ].
  ! !

!MADividerDescription methodsFor: 'accessing' stamp: 'kph 9/25/2007 16:04'!
spacer
	"Answer the value of spacer"

	^ spacer! !

!MADividerDescription methodsFor: 'accessing' stamp: 'kph 9/25/2007 16:04'!
spacer: anObject
	"Set the value of spacer"

	spacer := anObject! !

!MANonAccessingDescription class methodsFor: 'as yet unclassified' stamp: 'kph 3/19/2009 23:47'!
defaultAccessor
	^ MAPluggableAccessor dummy! !

!MANonAccessingDescription methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 19:58'!
= anObject
 ^ (self species = anObject species
		and: [ self cssClasses = anObject cssClasses ]).
			 	
	 ! !

!MANonAccessingDescription methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 20:21'!
cssClassesDefault

	^  OrderedCollection with: self label asLegalSelector ! !

!MANonAccessingDescription methodsFor: 'as yet unclassified' stamp: 'kph 1/31/2008 20:18'!
hash 
	^ self species hash bitXor: self cssClasses hash! !

!MANonAccessingDescription methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 03:00'!
isAvailable
	"only needs to be true is isVisible is false and you wish the field to show up in the 'available fields' list"

	^ true! !

!MANonAccessingDescription methodsFor: 'as yet unclassified' stamp: 'kph 10/15/2007 02:50'!
isVisible

	^ false! !

!MANonAccessingDescription methodsFor: 'as yet unclassified' stamp: 'kph 2/3/2008 21:06'!
isVisibleForItem: item  

	^ true! !

!Collection methodsFor: '*magritte-rdb' stamp: 'kph 7/1/2008 19:15'!
deleteFromDB

	"for a collection of WSModels to be committed in one shot. They all need to be in same db"
	
	Preferences dbHaltOnCommit ifTrue: [ self halt ].

	self size = 0 ifTrue: [ ^ self ].
	
	self first class databaseInterface execute: (' ; ' useToJoin: (self gather: [ :each | each sqlDeletes ])).
	! !

!Collection methodsFor: '*magritte-rdb' stamp: 'kph 1/14/2008 00:43'!
postCommit

	self do: [ :each | each postCommit ].
! !

!Collection methodsFor: '*magritte-rdb' stamp: 'kph 9/15/2008 21:54'!
postRealize

	self do: [ :each | each postRealize ].
! !

!Collection methodsFor: '*magritte-rdb' stamp: 'kph 10/22/2007 19:13'!
sqlUpdates

	^ self gather: [ :each | each sqlUpdates ]! !

!Collection methodsFor: '*magritte-rdb' stamp: 'kph 8/6/2008 20:48'!
storeOnDB

	"for a collection of WSModels to be committed in one shot"
	
	| db str toWrite |
	Preferences haltOnDbCommit ifTrue: [ self halt ].

	self ifEmpty: [ ^ self ].

	db := self first class databaseInterface.

	str := self asOrderedCollection readStream.
	
	[ str atEnd ] whileFalse: [

		toWrite := str next: db class maxNumberOfUpdates.
		db execute: (' ; ' useToJoin: toWrite sqlUpdates).		

		toWrite postCommit.	
	]

 ! !

!MARelationDescription methodsFor: '*magritte-rdb' stamp: 'kph 8/13/2007 16:13'!
joinRef

	^ self pointTo , '.' , self joinField! !

!MARelationDescription methodsFor: '*magritte-rdb' stamp: 'kph 8/13/2007 16:37'!
joinToField

	^ self propertyAt: #joinToField ifAbsent: [ self joinField ]! !

!MARelationDescription methodsFor: '*magritte-rdb' stamp: 'kph 9/11/2007 21:19'!
joinToField: fieldName

	self propertyAt: #joinToField put: fieldName ! !

!MATableRenderer methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 2/3/2008 22:20'!
visitNonAccessingDescription: anObject! !

!MATableRenderer methodsFor: '*magritte-rdb-descriptions' stamp: 'kph 2/3/2008 22:28'!
visitSelectItemDescription: anObject
 ! !

!MAClassDescription methodsFor: '*magritte-rdb' stamp: 'kph 9/18/2007 09:30'!
dbWrite: value to: model

	"this hook provides a place for description types to map their values into and out of the db"
	^ self accessor write: (value ifNil:[ self default ] ifNotNil: [ Smalltalk at: value asSymbol ]) to: model! !
MYSQL41 initialize!
